/* ImageDisplayer.java
 *
 * created: Fri Oct  9 1998
 *
 * This file is part of Artemis
 * 
 * Copyright (C) 1998,1999  Genome Research Limited
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * $Header: /nfs/disk222/yeastpub/Repository/powmap/diana/ImageDisplayer.java,v 1.7 1999/03/22 11:00:07 kmr Exp $
 */

package diana;

import java.awt.*;

/**
 *  ImageDisplayer class
 *
 *  @author Kim Rutherford
 *  @version $Id: ImageDisplayer.java,v 1.7 1999/03/22 11:00:07 kmr Exp $
 *
 */


public class ImageDisplayer extends Canvas {
  Image image;
  int width;
  int height;
  boolean true_size_known = false;
  MediaTracker tracker;

  public ImageDisplayer (String image_file, int width, int height) {
    Toolkit toolkit = Toolkit.getDefaultToolkit();
    image = toolkit.getImage(image_file);

//    System.out.println ("i:" + image);

    setBackground (Color.green);
    this.width = width;
    this.height = height;

    tracker = new MediaTracker(this);
    tracker.addImage(image, 0);
  }

  public Dimension getMininumSize () {
    return new Dimension (width, height);
  }
  
  public Dimension getPreferedSize () {
    return new Dimension (width, height);
  }

  public void paint (Graphics g) {
    if (!true_size_known) {
      int image_width = image.getWidth(this);
      int image_height = image.getHeight(this);

      if (tracker.checkAll(true)) {
        true_size_known = true;
      }

      if (((image_width > 0) && (width != image_width)) ||
          ((image_height > 0) && (height != image_height))) {
        width = image_width;
        height = image_height;
        setSize(width, height);
      }
    }
    
    g.drawImage(image, 0, 0, this);
  }
}
